set trimspool on
set validate off
col object_name for a30;
col object_type for a20;
spool aqadmin.log

accept queue_table_name    prompt 'Geef de naam van de queue tabel     : '
accept inbound_queue_name  prompt 'Geef de naam van de inbound queue   : '
accept outbound_queue_name prompt 'Geef de naam van de outbound queue  : '
prompt
prompt
prompt Create queue table for inboud and outbound message queues
prompt Enter value for queue_table name ...
begin
  dbms_aqadm.create_queue_table
    (queue_table        => '&queue_table_name'
    ,queue_payload_type => 'raw'
    ,sort_list          => 'ENQ_TIME'
    ,multiple_consumers => true
    ,comment => 'Queue table for inbound and outbound message queues'
    );
  commit;
end;
/

prompt Create inbound queue and outbound queue.
prompt Both queues will be created in queue_table &queue_table_name
prompt Enter values for queue_name ...
begin
  dbms_aqadm.create_queue
    (queue_name  => '&inbound_queue_name'
    ,queue_table => '&queue_table_name'
    ,comment     => 'Queue for inbound messages'
    );
  dbms_aqadm.create_queue
    (queue_name  => '&outbound_queue_name'
    ,queue_table => '&queue_table_name'
    ,comment     => 'Queue for outbound messages'
    );
  commit;
end;
/

prompt starting all queues ...
execute dbms_aqadm.start_queue(queue_name => '&inbound_queue_name')
execute dbms_aqadm.start_queue(queue_name => '&outbound_queue_name')

prompt Create subscribers for inbound queue and for outbound queue ...
begin
  dbms_aqadm.add_subscriber
    (queue_name => '&inbound_queue_name'
    ,subscriber => sys.aq$_agent('inbound_consumer', null, null)
    );
  dbms_aqadm.add_subscriber
    (queue_name => '&outbound_queue_name'
    ,subscriber => sys.aq$_agent('outbound_consumer', null, null)
    );
  commit;
end;
/

prompt en deze obejcten zijn aangemaakt ...
prompt
select object_type, object_name from user_objects 
where object_name like '%AQ$%' or object_type like 'QUEUE%'
order by 1,2
/
prompt
prompt Details aangemaakte queue tabel
select * from user_queue_tables
/
prompt
prompt Details aangemaakte queues
select * from user_queues
/

spool off;

