create or replace procedure deq(p_wait boolean default false)
is
  /* Dequeue from inbound queue: */
  t_dequeue_options     sys.dbms_aq.dequeue_options_t;
  t_message_properties  sys.dbms_aq.message_properties_t;
  t_message_handle      raw(16);
  t_payload             raw(32670);
  t_message             sys.XMLType;
  l_empty_queue         boolean := false;
  e_empty_queue         exception;
  pragma exception_init (e_empty_queue, -25228);
begin
  if p_wait
  then 
    t_dequeue_options.wait := dbms_aq.NO_WAIT;
  else 
    t_dequeue_options.wait := dbms_aq.FOREVER;
  end if;

  -- TODO: fix consumer naam en inbound queue naam.
  t_dequeue_options.consumer_name := 'inbound_consumer';

  begin
    while not l_empty_queue
    loop
      dbms_aq.dequeue
        (queue_name         => 'inbound queue name'
        ,dequeue_options    => t_dequeue_options
        ,message_properties => t_message_properties
        ,payload            => t_payload
        ,msgid              => t_message_handle);
      -- parse raw XML naar XMLType
      t_message := sys.XMLType(utl_raw.cast_to_varchar2(t_payload));
      --
      -- TODO
      -- Extraheer de inhoud van het XML bericht en print naar output of insert in een aan te maken tabel.
      -- bijvoorbeeld:
      dbms_output.put('Afzender : ' || t_message.extract('//afzender/text()').getStringVal());
      dbms_output.put('Datumtijd: ' || 'extraheer de datum-tijd uit de payload');
      dbms_output.put('Tekst    : ' || 'extraheer de tekst uit de payload, zonder de CDATA node!');
      --
      -- commit zorgt ervoor dat de dequeue transactie afgesloten wordt.
      commit;
    end loop;
  exception
    when e_empty_queue then
    l_empty_queue := true;
  end;
exception
  when others then
  raise_application_error(-20010, sqlerrm);
end deq;
/
show err

