set trimspool on
spool enq_msg.log

prompt Create procedure enq
create or replace procedure enq(p_text varchar2)
is
  enqueue_options     sys.dbms_aq.enqueue_options_t;
  message_properties  sys.dbms_aq.message_properties_t;
  message_handle      raw(16);
  message             sys.XMLType;
begin
  --
  -- maak op eenvoudige wijze een XML bericht.
  message := sys.XMLType('<?xml version="1.0" ?>'
               || '<bericht>'
               || '<datumtijd>' || to_char(sysdate, 'dd-mm-yyyy hh24:mi:ss') || '</datumtijd>'
               || '<afzender>' || user || '</afzender>'
               || '<text><![CDATA[' || p_text || ']]></text></bericht');
  -- Schemanaam-prefix blijkt erg belangrijk, anders kunnen andere users 
  -- de queue niet vinden (ook al is er een synonym gedefinieerd voor de queue)
  --
  -- TODO
  -- Vul in de queue naam van de outboud queue.
  --
  -- Speel met enqueue opties, zoals de retentietijd, de correlatie-ID en controleer wat
  -- InterConnect ermee doet.
  dbms_aq.enqueue
    (queue_name         => 'outbound_queue_name'
    ,enqueue_options    => enqueue_options
    ,message_properties => message_properties
    ,payload            => utl_raw.cast_to_raw(message.getStringVal())
    ,msgid              => message_handle
    );
  --
  -- commit zorgt ervoor dat het bericht definitief enqueued wordt.
  commit;
exception
  when others then
  raise_application_error(-20010, sqlerrm);
end;
/
show error
spool off;

